<?php
namespace Teknisa\CRM\Factory;

use Doctrine\ORM\EntityManager;

class crm20000CasoAnexosFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection       = $entityManager->getConnection();
    }
    
    public function requestForDeleteFilesByOriginNumber($paramsDeleteFiles){
        
        $queryDelete = "DELETE CRM_ANEXOCONTATO
                        WHERE NRORIGEM = :NRORIGEM";
        
        try{
            $std = $this->connection->prepare($queryDelete);
            $std->execute($paramsDeleteFiles);
        }
        catch(\Exception $e){
            throw $e;
        };
            
    }
    
    public function requestForGetFilesUrlByOriginNumber($paramsSelectUrls){
        
        $select = "SELECT DSCAMINHO
                    FROM CRM_ANEXOCONTATO
                    WHERE NRORIGEM = :NRORIGEM";
        try{
            $std = $this->connection->prepare($select);
            $std->execute($paramsSelectUrls);
            $fileUrls = $std->fetchAll();
        }
        catch(\Exception $e){
            throw $e;
        };
        
        return $fileUrls;
        
    }
    public function requestForUpdateIdAnnex($paramsUpdateIdAnnex){
        
        $update = "UPDATE EVOLCONT
                   SET IDANEXOEVOLCONT = :IDANEXOEVOLCONT
                   WHERE NRSEQEVOLCONT = :NRSEQEVOLCONT";
                   
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsUpdateIdAnnex);
        }
        catch(\Exception $e){
            throw $e;
        }
    }
    
    public function requestForCheckIfHasAnnex($paramsCheckIfHasAnnex){
        
        $select = "SELECT *
                   FROM CRM_ANEXOCONTATO ANEX JOIN EVOLCONT EVO ON ANEX.NRORIGEM = EVO.NRSEQEVOLCONT
                   WHERE NRORIGEM = :NRORIGEM";
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute($paramsCheckIfHasAnnex);
            $annexes = $std->fetchAll();
        }
        catch(\Exception $e){
            throw $e;
        }
        
        return sizeof($annexes) > 0;
        
    }
}