DROP VIEW ETL_TEK_MOVIBANCARIO_MES
/

CREATE VIEW ETL_TEK_MOVIBANCARIO_MES AS
   (SELECT CDEMPRESA, CDREDUCONT, DSCONTCORR, DSFINALIDADE_CONTCORR, 
           DSANO, DSBIMESTRE, DSTRIMESTRE, DSSEMESTRE, DSANOMES, 
           NVL(VR_SALDO_INICIAL_MB, 0) VR_SALDO_INICIAL_MB, 
           NVL(VR_TRANSFERENCIA_CREDITO_MB, 0) VR_TRANSFERENCIA_CREDITO_MB, 
           NVL(VR_LANCAMENTO_CREDITO_MB, 0) VR_LANCAMENTO_CREDITO_MB, 
           NVL(VR_CONTA_RECEBIDA_MB, 0) VR_CONTA_RECEBIDA_MB,
           NVL(VR_TRANSFERENCIA_DEBITO_MB, 0) VR_TRANSFERENCIA_DEBITO_MB, 
           NVL(VR_LANCAMENTO_DEBITO_MB, 0) VR_LANCAMENTO_DEBITO_MB, 
           NVL(VR_CONTA_PAGA_MB, 0) VR_CONTA_PAGA_MB,
           NVL(VR_SALDO_INICIAL_MB, 0)+NVL(VR_TRANSFERENCIA_CREDITO_MB, 0)+NVL(VR_LANCAMENTO_CREDITO_MB, 0)+NVL(VR_CONTA_RECEBIDA_MB, 0)
                                      -NVL(VR_TRANSFERENCIA_DEBITO_MB, 0)-NVL(VR_LANCAMENTO_DEBITO_MB, 0)-NVL(VR_CONTA_PAGA_MB, 0) VR_SALDO_FINAL_MB
      FROM (SELECT C.CDEMPRESA, -- DIMENSO 00264 EMPRESA
                   DSCONTCORR,
                   CASE WHEN SUBSTR(C.DSCONTCORR, 1, 2) = 'AP' THEN 'Aplicao Financeira'
                        WHEN SUBSTR(C.DSCONTCORR, 1, 2) = 'CC' THEN 'Conta Corrente'
                        ELSE 'Idefinida'
                         END AS DSFINALIDADE_CONTCORR, -- DIMENSO 06001 FINALIDADE DA CONTA
                   M.CDREDUCONT, -- DIMENSO 06000 CONTA CORRENTE
                   M.DSANO, -- DIMENSO 00025 ANO (YYYY)
                   TO_CHAR(TRUNC((M.DSMES - 1) / 2) + 1)||' Bim' DSBIMESTRE, -- DIMENSO 00011 BIMESTRE
                   TO_CHAR(TRUNC((M.DSMES - 1) / 3) + 1)||' Tri' DSTRIMESTRE, -- DIMENSO 00012 TRIMESTRE
                   TO_CHAR(TRUNC((M.DSMES - 1) / 6) + 1)||' Sem' DSSEMESTRE, -- DIMENSO 00013 SEMESTRE
                   M.DSANOMES, -- DIMENSO 00027 MS (YYYY-MM)
                   (SELECT VRSDOCCORR
                      FROM SDOCCORR
                     WHERE CDREDUCONT = M.CDREDUCONT
                       AND DTSDOCCORR = (SELECT MAX(DTSDOCCORR)
                                          FROM SDOCCORR
                                         WHERE CDREDUCONT = M.CDREDUCONT
                                           AND DTSDOCCORR <= DTSALDO)) VR_SALDO_INICIAL_MB,
                   VR_TRANSFERENCIA_CREDITO_MB, VR_LANCAMENTO_CREDITO_MB, VR_CONTA_RECEBIDA_MB,
                   VR_TRANSFERENCIA_DEBITO_MB, VR_LANCAMENTO_DEBITO_MB, VR_CONTA_PAGA_MB
              FROM CONTCORR C, 
                   (SELECT MB.CDREDUCONT, MB.NRORG,  
                           TO_CHAR(MB.DTMOVBANC, 'YYYY') DSANO,
                           TO_CHAR(MB.DTMOVBANC, 'MM') DSMES,
                           TO_CHAR(MB.DTMOVBANC, 'YYYY-MM') DSANOMES,
                           TO_DATE(TO_CHAR(MB.DTMOVBANC, 'YYYY-MM')||'-01', 'YYYY-MM-DD')-1 DTSALDO,
                           SUM(CASE WHEN MB.IDORIGMBANC = 'T' AND MB.IDMOVBANC = 'C' THEN VRMOVBANC ELSE 0 END) VR_TRANSFERENCIA_CREDITO_MB,
                           SUM(CASE WHEN MB.IDORIGMBANC = 'T' AND MB.IDMOVBANC = 'D' THEN VRMOVBANC ELSE 0 END) VR_TRANSFERENCIA_DEBITO_MB,
                           SUM(CASE WHEN MB.IDORIGMBANC = 'C' THEN VRMOVBANC ELSE 0 END) VR_LANCAMENTO_CREDITO_MB,
                           SUM(CASE WHEN MB.IDORIGMBANC = 'D' THEN VRMOVBANC ELSE 0 END) VR_LANCAMENTO_DEBITO_MB, 
                           SUM(CASE WHEN MB.IDORIGMBANC = 'R' THEN VRMOVBANC ELSE 0 END) VR_CONTA_RECEBIDA_MB,
                           SUM(CASE WHEN MB.IDORIGMBANC = 'P' THEN VRMOVBANC ELSE 0 END) VR_CONTA_PAGA_MB
                      FROM MOVBANCARIO MB
                     GROUP BY MB.CDREDUCONT, MB.NRORG, TO_CHAR(MB.DTMOVBANC, 'YYYY'), TO_CHAR(MB.DTMOVBANC, 'MM'), TO_CHAR(MB.DTMOVBANC, 'YYYY-MM')) M
             WHERE C.CDREDUCONT = M.CDREDUCONT
               AND C.NRORG = M.NRORG))
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_TEK_MOVIBANCARIO_MES','0.00.000'); END;
/
